﻿unit u_prep_query_cc_nb_movimentos;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, DBCtrls,
  ExtCtrls, EditBtn, BGRACustomDrawn, RTTICtrls, LSControls, SynEdit, LazUTF8;

type
  { Tfrm_prep_query_cc_nb_movimentos }

  Tfrm_prep_query_cc_nb_movimentos = class(TForm)
    B_ExecQuery: TButton;
    B_Limpar: TButton;
    B_Sair: TButton;
    CB_op_analisado: TComboBox;
    CB_op_cod_tipo_movimento: TComboBox;
    CB_op_moeda_origem: TComboBox;
    CB_op_notas: TComboBox;
    CB_op_montante: TComboBox;
    CB_op_estado: TComboBox;
    CB_op_nome_comercio: TComboBox;
    CB_op_taxas_comissoes: TComboBox;
    CB_op_desc_factura: TComboBox;
    CB_op_pk_movimento: TComboBox;
    CB_op_cartao_activo: TComboBox;
    CB_op_montante_moeda_orig: TComboBox;
    CB_op_moeda_debito: TComboBox;
    E_analisado: TEdit;
    E_cod_tipo_movimento: TEdit;
    E_moeda_origem: TEdit;
    E_notas: TEdit;
    E_montante: TEdit;
    E_estado: TEdit;
    E_nome_comercio: TEdit;
    E_taxas_comissoes: TEdit;
    E_desc_factura: TEdit;
    E_PK_movimento: TEdit;
    E_Cartao_Activo: TEdit;
    E_montante_moeda_orig: TEdit;
    E_moeda_debito: TEdit;
    L_analisado: TLabel;
    L_cod_tipo_movimento: TLabel;
    L_moeda_origem: TLabel;
    L_notas: TLabel;
    L_montante: TLabel;
    L_estado: TLabel;
    L_nome_comercio: TLabel;
    L_taxas_comissoes: TLabel;
    L_desc_factura: TLabel;
    L_PK_movimento: TLabel;
    L_Cartao_Activo: TLabel;
    L_montante_moeda_orig: TLabel;
    L_moeda_debito: TLabel;
    procedure B_ExecQueryClick(Sender: TObject);
    procedure B_LimparClick(Sender: TObject);
    procedure B_SairClick(Sender: TObject);
    procedure CB_op_analisadoChange(Sender: TObject);
    procedure CB_op_cod_tipo_movimentoChange(Sender: TObject);
    procedure CB_op_moeda_origemChange(Sender: TObject);
    procedure CB_op_montanteChange(Sender: TObject);
    procedure CB_op_estadoChange(Sender: TObject);
    procedure CB_op_montante_moeda_origChange(Sender: TObject);
    procedure CB_op_nome_comercioChange(Sender: TObject);
    procedure CB_op_taxas_comissoesChange(Sender: TObject);
    procedure CB_op_desc_facturaChange(Sender: TObject);
    procedure CB_op_pk_movimentoChange(Sender: TObject);
    procedure CB_op_moeda_debitoChange(Sender: TObject);
    procedure CB_op_Cartao_ActivoChange(Sender: TObject);
    procedure E_analisadoEnter(Sender: TObject);
    procedure E_cod_tipo_movimentoEnter(Sender: TObject);
    procedure E_Cartao_ActivoEnter(Sender: TObject);
    procedure E_moeda_origemEnter(Sender: TObject);
    procedure E_montanteEnter(Sender: TObject);
    procedure E_estadoEnter(Sender: TObject);
    procedure E_nome_comercioEnter(Sender: TObject);
    procedure E_notasEnter(Sender: TObject);
    procedure E_taxas_comissoesEnter(Sender: TObject);
    procedure E_desc_facturaEnter(Sender: TObject);
    procedure E_PK_movimentoEnter(Sender: TObject);
    procedure E_montante_moeda_origEnter(Sender: TObject);
    procedure E_moeda_debitoEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private

  public

  end;

var
  frm_prep_query_cc_nb_movimentos: Tfrm_prep_query_cc_nb_movimentos;
  c_where,
  clausula_where,
  SQL_text: string;

  op_PK_movimento,
  op_estado,
  op_data_val,
  op_Cartao_Activo,
  moeda_debito,
  op_desc_factura,
  op_debito,
  op_moeda_debito,
  op_credito,
  p_cod_tipo_movimento,
  op_montante_moeda_orig,
  op_moeda_origem,
  op_analisado,
  notas: string;


implementation
  uses u_dm_movimentos, u_edita_cc_nb_movimentos;

{$R *.frm}

{ Tfrm_prep_query_cc_nb_movimentos }


procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_Cartao_ActivoChange(Sender: TObject);
begin
  case CB_op_cartao_activo.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_Cartao_Activo := '>';
    1: op_Cartao_Activo := '<';
    2: op_Cartao_Activo := '=';
    3: op_Cartao_Activo := '<=';
    4: op_Cartao_Activo := '>=';
    5: op_Cartao_Activo := 'between';
    6: op_Cartao_Activo := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_analisadoChange(Sender: TObject);
begin
  case CB_op_analisado.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_analisado := '>';
    1: op_analisado := '<';
    2: op_analisado := '=';
    3: op_analisado := '<=';
    4: op_analisado := '>=';
    5: op_analisado := 'between';
    6: op_analisado := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.B_ExecQueryClick(Sender: TObject);
  var
  field_no: integer;
  field_nome,
  field_tipo: string;

  menor_que: string = #60;
  igual_a: string = #61;
  maior_que: string = #62;
  menor_ou_igual: string = '<=';
  maior_ou_igual: string = '>=';
  like: string = 'like';
  between: string = 'between';
  interrogacao: string = 'SQL_livre';   //#63;
  percentagem: string = #37;
  espaco: string = #32;
  plica: string = #39;

begin
  while field_no < frm_dm_movimentos.SQLQ_cartoes_NB.FieldCount do
  begin
    field_no := field_no + 1;
    field_nome := frm_dm_movimentos.SQLQ_cartoes_NB.Fields.FieldByNumber(field_no).DisplayName;
//    Field_tipo := SQLQ_movimentos.Fields.FieldByName(field_nome);
//    showmessage(SQLQ_movimentos.Params[field_no].DisplayName);
//    showmessage(DBG_movimentos.Columns.Items[field_no].DisplayFormat);    não mostra nada porque a grelha não tem formato para as colunas
  end;

// forma a claúsula WHERE para dar seguimento à execução da QUERY
  E_cartao_activo.Text := UTF8UpperCase(frm_edita_cc_nb_movimentos.que_cartao);   // para afectar toas as pesquisas onde cartao seja argumento
  clausula_where := 'where 1 = 1 AND upper(cartao) = ' + chr(39) + UTF8UpperCase(frm_edita_cc_nb_movimentos.que_cartao) + chr(39) ;

  if E_PK_movimento.Text <> '' then
  begin
    if (op_PK_movimento = igual_a) or (op_PK_movimento = menor_que) or (op_PK_movimento = maior_que) or (op_PK_movimento = menor_ou_igual) or (op_PK_movimento = maior_ou_igual) then
      clausula_where := clausula_where + ' and pk_movimentos_cc_nb ' + op_PK_movimento + E_PK_movimento.Text
    else if (op_PK_movimento = like) then
      clausula_where := clausula_where + ' and pk_movimentos_cc_nb::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_PK_movimento.Text + percentagem + (chr(39))
    else if (op_PK_movimento = between) then
      clausula_where := clausula_where + ' and pk_movimentos_cc_nb ' + espaco + between + espaco + stringReplace(E_PK_movimento.Text,'*',' and ',[rfReplaceAll])
    else if (op_PK_movimento = interrogacao) then
      begin
//      clausula_where := clausula_where + ' and pk_movimentos_cgd ' + espaco + between + espaco + stringReplace(E_PK_movimento.Text,'*',' and ',[rfReplaceAll]);
      end;
  end;
//
  if E_estado.Text <> '' then
  begin
    if (op_estado = igual_a) or (op_estado = menor_que) or (op_estado = maior_que) or (op_estado = menor_ou_igual) or (op_estado = maior_ou_igual) then
      clausula_where := clausula_where + ' and estado ' +  op_estado + chr(39) + E_estado.Text + chr(39)
    else if op_estado = like then
      clausula_where := clausula_where + ' and estado::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_estado.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and estado ' + espaco + between + espaco + plica + stringReplace(E_estado.Text,'*',''' and ''',[rfReplaceAll]) + plica;
  end;
//
  if E_nome_comercio.Text <> '' then
  begin
    if (op_data_val = igual_a) or (op_data_val = menor_que) or (op_data_val = maior_que) or (op_data_val = menor_ou_igual) or (op_data_val = maior_ou_igual) then
      clausula_where := clausula_where + ' and nome_comercio ' +  op_data_val + plica +  E_nome_comercio.Text + plica
    else if op_data_val = like then
      clausula_where := clausula_where + ' and nome_comercio::text ' + espaco +  like  + espaco + plica + percentagem + E_nome_comercio.Text + percentagem + plica
    else
      clausula_where := clausula_where + ' and nome_comercio ' + espaco + between + espaco + plica + stringReplace(E_nome_comercio.Text,'*',''' and ''',[rfReplaceAll]) + plica;
  end;
//
  if E_desc_factura.Text <> '' then
  begin
    E_desc_factura.Text := UpperCase(E_desc_factura.Text);
    if (op_desc_factura = igual_a) then
      clausula_where := clausula_where + ' and trim(desc_factura) ' +  op_desc_factura + espaco +  plica + E_desc_factura.Text + plica
    else
      clausula_where := clausula_where + ' and trim(upper(desc_factura))::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_desc_factura.Text + percentagem + (chr(39));
  end;
//
  if E_Cartao_Activo.Text <> '' then
  begin
    E_cartao_activo.Text := UTF8UpperCase(frm_edita_cc_nb_movimentos.que_cartao);
//    E_Cartao_Activo.Text := UpperCase(E_Cartao_Activo.Text);
    if (op_Cartao_Activo = igual_a) then
      clausula_where := clausula_where + ' and trim(upper(cartao)::text) ' +  op_Cartao_Activo + espaco +  plica + E_Cartao_Activo.Text + plica
    else    //if op_cartao_activo = like then
      clausula_where := clausula_where + ' and trim(upper(cartao)::text) ' + espaco +  like  + espaco + chr(39) + percentagem + E_Cartao_Activo.Text + percentagem + (chr(39));
  end;
//
  if E_taxas_comissoes.Text <> '' then
  begin
    E_taxas_comissoes.Text := stringReplace(E_taxas_comissoes.Text,',','.',[rfReplaceAll]);
    if (op_debito = igual_a) or (op_debito = menor_que) or (op_debito = maior_que) or (op_debito = menor_ou_igual) or (op_debito = maior_ou_igual) then
      clausula_where := clausula_where + ' and taxas_comissoes ' + op_debito + E_taxas_comissoes.Text
    else if (op_debito = like) then
      clausula_where := clausula_where + ' and taxas_comissoes::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_taxas_comissoes.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and taxas_comissoes ' + espaco + between + espaco + stringReplace(E_taxas_comissoes.Text,'*',' and ',[rfReplaceAll]);
  end;
//
  if E_montante.Text <> '' then
  begin
    E_montante.Text := stringReplace(E_montante.Text,',','.',[rfReplaceAll]);
    if (op_credito = igual_a) or (op_credito = menor_que) or (op_credito = maior_que) or (op_credito = menor_ou_igual) or (op_credito = maior_ou_igual) then
      clausula_where := clausula_where + ' and montante ' + op_credito + E_montante.Text
    else if (op_credito = like) then
      clausula_where := clausula_where + ' and montante::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_montante.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and montante ' + espaco + between + espaco + stringReplace(E_montante.Text,'*',' and ',[rfReplaceAll]);
  end;
  //
  if E_moeda_origem.Text <> '' then
  begin
    E_moeda_origem.Text := stringReplace(E_moeda_origem.Text,',','.',[rfReplaceAll]);
    if (op_moeda_origem = igual_a) or (op_moeda_origem = menor_que) or (op_moeda_origem = maior_que) or (op_moeda_origem = menor_ou_igual) or (op_moeda_origem = maior_ou_igual) then
      clausula_where := clausula_where + ' and moeda_origem ' + op_moeda_origem + plica + E_moeda_origem.Text + plica
    else if (op_moeda_origem = like) then
      clausula_where := clausula_where + ' and moeda_origem::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_moeda_origem.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and moeda_origem ' + espaco + between + espaco + stringReplace(E_moeda_origem.Text,'*',' and ',[rfReplaceAll]);
  end;
  //
  if E_montante_moeda_orig.Text <> '' then
  begin
    E_montante_moeda_orig.Text := stringReplace(E_montante_moeda_orig.Text,',','.',[rfReplaceAll]);
    if (op_montante_moeda_orig = igual_a) or (op_montante_moeda_orig = menor_que) or (op_montante_moeda_orig = maior_que) or (op_montante_moeda_orig = menor_ou_igual) or (op_montante_moeda_orig = maior_ou_igual) then
      clausula_where := clausula_where + ' and montante_moeda_orig ' + op_montante_moeda_orig + E_montante_moeda_orig.Text
    else if (op_montante_moeda_orig = like) then
      clausula_where := clausula_where + ' and montante_moeda_orig::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_montante_moeda_orig.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and montante_moeda_orig ' + espaco + between + espaco + stringReplace(E_montante_moeda_orig.Text,'*',' and ',[rfReplaceAll]);
  end;
//
  if E_moeda_debito.Text <> '' then
  begin
    E_moeda_debito.Text := UpperCase(E_moeda_debito.Text);
    if (op_moeda_debito = igual_a) then
      clausula_where := clausula_where + ' and trim(moeda_debito) ' +  op_moeda_debito + espaco +  plica + E_moeda_debito.Text + plica
    else
      clausula_where := clausula_where + ' and trim(upper(moeda_debito))::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_moeda_debito.Text + percentagem + (chr(39));
  end;
//
  if E_cod_tipo_movimento.Text <> '' then
  begin
    E_cod_tipo_movimento.Text := stringReplace(E_cod_tipo_movimento.Text,',','.',[rfReplaceAll]);
    if (op_cod_tipo_movimento = igual_a) or (op_cod_tipo_movimento = menor_que) or (op_cod_tipo_movimento = maior_que) or (op_cod_tipo_movimento = menor_ou_igual) or (op_cod_tipo_movimento = maior_ou_igual) then
      clausula_where := clausula_where + ' and cod_tipo_movimento ' + op_cod_tipo_movimento + E_cod_tipo_movimento.Text
    else if (op_cod_tipo_movimento = like) then
      clausula_where := clausula_where + ' and cod_tipo_movimento::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_cod_tipo_movimento.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and cod_tipo_movimento ' + espaco + between + espaco + stringReplace(E_cod_tipo_movimento.Text,'*',' and ',[rfReplaceAll]);
  end;
//
  if E_analisado.Text <> '' then
  begin
    E_analisado.Text := UpperCase(E_analisado.Text);
    if (op_analisado = igual_a) then
      clausula_where := clausula_where + ' and trim(analisado) ' +  op_analisado + espaco +  plica + E_analisado.Text + plica
    else    //if op_analisado = like then
      clausula_where := clausula_where + ' and trim(analisado)::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_analisado.Text + percentagem + (chr(39));
  end;

  SQL_Text := 'select * from sch_conta.movimentos_cc_nb ' + clausula_where + ' order by estado ASC';   // completa a formação da instrução SQL a sujeitar à BD

  frm_dm_movimentos.SQLQ_cartoes_NB.SQL.Text := SQL_Text;
  frm_dm_movimentos.SQLQ_cartoes_NB.Active := FALSE;
  showmessage(frm_dm_movimentos.SQLQ_cartoes_NB.SQL.Text);
  frm_dm_movimentos.SQLQ_cartoes_NB.Active := TRUE;

  frm_dm_movimentos.SQLQ_total_cartoes_NB.Refresh;    // refresca a contagem de movimentos na BD

  E_montante_moeda_orig.visible := FALSE;
  E_nome_comercio.visible := FALSE;
  E_montante.visible := FALSE;
  E_desc_factura.visible := FALSE;
  E_taxas_comissoes.visible := FALSE;
  E_PK_movimento.visible := FALSE;
  E_estado.visible := FALSE;
  E_moeda_debito.visible := FALSE;
  E_analisado.visible := FALSE;
//
  L_montante_moeda_orig.visible := FALSE;
  L_nome_comercio.visible := FALSE;
  L_montante.visible := FALSE;
  L_desc_factura.visible := FALSE;
  L_taxas_comissoes.visible := FALSE;
  L_PK_movimento.visible := FALSE;
  L_estado.visible := FALSE;
  L_moeda_debito.visible := FALSE;
  L_analisado.visible := FALSE;

  Hide;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.B_LimparClick(Sender: TObject);
begin
  E_cartao_activo.Clear;
  CB_op_cartao_activo.Clear;
  CB_op_cartao_activo.Text := 'Operador';
  CB_op_cartao_activo.Visible := FALSE;

  E_PK_movimento.Clear;
  CB_op_pk_movimento.Clear;
  CB_op_pk_movimento.Text := 'Operador';
  CB_op_pk_movimento.Visible := FALSE;

  E_estado.Clear;
  CB_op_estado.Clear;
  CB_op_estado.Text := 'Operador';
  CB_op_estado.Visible := FALSE;

  E_nome_comercio.Clear;
  CB_op_nome_comercio.Clear;
  CB_op_nome_comercio.Text := 'Operador';
  CB_op_nome_comercio.Visible := FALSE;

  E_desc_factura.Clear;
  CB_op_desc_factura.Clear;
  CB_op_desc_factura.Text := 'Operador';
  CB_op_desc_factura.Visible := FALSE;

  E_taxas_comissoes.Clear;
  CB_op_taxas_comissoes.Clear;
  CB_op_taxas_comissoes.Text := 'Operador';
  CB_op_taxas_comissoes.Visible := FALSE;

  E_montante.Clear;
  CB_op_montante.Clear;
  CB_op_montante.Text := 'Operador';
  CB_op_montante.Visible := FALSE;

  E_montante_moeda_orig.Clear;
  CB_op_montante_moeda_orig.Clear;
  CB_op_montante_moeda_orig.Text := 'Operador';
  CB_op_montante_moeda_orig.Visible := FALSE;

  E_moeda_debito.Clear;
  CB_op_moeda_debito.Clear;
  CB_op_moeda_debito.Text := 'Operador';
  CB_op_moeda_debito.Visible := FALSE;

  E_moeda_origem.Clear;
  CB_op_moeda_origem.Clear;
  CB_op_moeda_origem.Text := 'Operador';
  CB_op_moeda_origem.Visible := FALSE;

  E_cod_tipo_movimento.Clear;
  CB_op_cod_tipo_movimento.Clear;
  CB_op_cod_tipo_movimento.Text := 'Operador';
  CB_op_cod_tipo_movimento.Visible := FALSE;

  E_analisado.Clear;
  CB_op_analisado.Clear;
  CB_op_analisado.Text := 'Operador';
  CB_op_analisado.Visible := FALSE;

  E_notas.Clear;
  CB_op_notas.Clear;
  CB_op_notas.Text := 'Operador';
  CB_op_notas.Visible := FALSE;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.B_SairClick(Sender: TObject);
begin
  Hide;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_analisadoEnter(Sender: TObject);
begin
  E_analisado.Width := 50;
  CB_op_analisado.Items.Clear;
  CB_op_analisado.Text:= 'Operador';
  CB_op_analisado.Items.Add('  >  ');
  CB_op_analisado.Items.Add('  <  ');
  CB_op_analisado.Items.Add('  =  ' );
  CB_op_analisado.Items.Add('  <=  ' );
  CB_op_analisado.Items.Add('  >=  ' );
  CB_op_analisado.Items.Add('  between  ');
  CB_op_analisado.Items.Add('  like  ');
  CB_op_analisado.Color := $0064FFFF;
  CB_op_analisado.Visible := TRUE;

  CB_op_analisado.Left := E_analisado.Left + E_analisado.Width + 5;
  CB_op_analisado.Top := E_analisado.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_cod_tipo_movimentoChange(Sender: TObject);
begin
  case CB_op_cod_tipo_movimento.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_cod_tipo_movimento:= '>';
    1: op_cod_tipo_movimento := '<';
    2: op_cod_tipo_movimento := '=';
    3: op_cod_tipo_movimento := '<=';
    4: op_cod_tipo_movimento := '>=';
    5: op_cod_tipo_movimento := 'between';
    6: op_cod_tipo_movimento := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_moeda_origemChange(
  Sender: TObject);
begin
    case CB_op_moeda_origem.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_moeda_origem := '>';
    1: op_moeda_origem := '<';
    2: op_moeda_origem := '=';
    3: op_moeda_origem := '<=';
    4: op_moeda_origem := '>=';
    5: op_moeda_origem := 'between';
    6: op_moeda_origem := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_cod_tipo_movimentoEnter(Sender: TObject);
begin
  E_cod_tipo_movimento.Width := 50;
  CB_op_cod_tipo_movimento.Items.Clear;
  CB_op_cod_tipo_movimento.Text:= 'Operador';
  CB_op_cod_tipo_movimento.Items.Add('  >  ');
  CB_op_cod_tipo_movimento.Items.Add('  <  ');
  CB_op_cod_tipo_movimento.Items.Add('  =  ' );
  CB_op_cod_tipo_movimento.Items.Add('  <=  ' );
  CB_op_cod_tipo_movimento.Items.Add('  >=  ' );
  CB_op_cod_tipo_movimento.Items.Add('  between  ');
  CB_op_cod_tipo_movimento.Items.Add('  like  ');
  CB_op_cod_tipo_movimento.Color := $0064FFFF;
  CB_op_cod_tipo_movimento.Visible := TRUE;

  CB_op_cod_tipo_movimento.Left := E_cod_tipo_movimento.Left + E_cod_tipo_movimento.Width + 5;
  CB_op_cod_tipo_movimento.Top := E_cod_tipo_movimento.Top;
end;


procedure Tfrm_prep_query_cc_nb_movimentos.E_Cartao_ActivoEnter(Sender: TObject);
begin
  E_Cartao_Activo.Width := 80;
  CB_op_cartao_activo.Items.Clear;
  CB_op_cartao_activo.Text := 'Operador';
  CB_op_cartao_activo.Items.Add('  >  ');
  CB_op_cartao_activo.Items.Add('  <  ');
  CB_op_cartao_activo.Items.Add('  =  ' );
  CB_op_cartao_activo.Items.Add('  <=  ' );
  CB_op_cartao_activo.Items.Add('  >=  ' );
  CB_op_cartao_activo.Items.Add('  between  ');
  CB_op_cartao_activo.Items.Add('  like  ');
//  CB_op_cartao_activo.Items.Add('  ?  ');  // igual ao seguinte
  CB_op_cartao_activo.Color := $0064FFFF;
  CB_op_cartao_activo.Visible := TRUE;

  CB_op_cartao_activo.Left := E_Cartao_Activo.Left + E_PK_movimento.Width + 5;
  CB_op_cartao_activo.Top := E_Cartao_Activo.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_moeda_origemEnter(Sender: TObject);
begin
  E_moeda_origem.Width := 50;
  CB_op_moeda_origem.Items.Clear;
  CB_op_moeda_origem.Text:= 'Operador';
  CB_op_moeda_origem.Items.Add('  >  ');
  CB_op_moeda_origem.Items.Add('  <  ');
  CB_op_moeda_origem.Items.Add('  =  ' );
  CB_op_moeda_origem.Items.Add('  <=  ' );
  CB_op_moeda_origem.Items.Add('  >=  ' );
  CB_op_moeda_origem.Items.Add('  between  ');
  CB_op_moeda_origem.Items.Add('  like  ');
  CB_op_moeda_origem.Color := $0064FFFF;
  CB_op_moeda_origem.Visible := TRUE;

  CB_op_moeda_origem.Left := E_moeda_origem.Left + E_cod_tipo_movimento.Width + 5;
  CB_op_moeda_origem.Top := E_moeda_origem.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_montanteEnter(Sender: TObject);
begin
  E_montante.Width := 100;
  CB_op_montante.Items.Clear;
  CB_op_montante.Text:= 'Operador';
  CB_op_montante.Items.Add('  >  ');
  CB_op_montante.Items.Add('  <  ');
  CB_op_montante.Items.Add('  =  ' );
  CB_op_montante.Items.Add('  <=  ' );
  CB_op_montante.Items.Add('  >=  ' );
  CB_op_montante.Items.Add('  between  ');
  CB_op_montante.Items.Add('  like  ');
  CB_op_montante.Color := $0064FFFF;
  CB_op_montante.Visible := TRUE;

  CB_op_montante.Left := E_montante.Left + E_montante.Width + 5;
  CB_op_montante.Top := E_montante.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_desc_facturaEnter(Sender: TObject);
begin
  E_desc_factura.Width := 225;
  CB_op_desc_factura.Items.Clear;
  CB_op_desc_factura.Text:= 'Operador';
  CB_op_desc_factura.Items.Add('  >  ');
  CB_op_desc_factura.Items.Add('  <  ');
  CB_op_desc_factura.Items.Add('  =  ' );
  CB_op_desc_factura.Items.Add('  <=  ' );
  CB_op_desc_factura.Items.Add('  >=  ' );
  CB_op_desc_factura.Items.Add('  between  ');
  CB_op_desc_factura.Items.Add('  like  ');
  CB_op_desc_factura.Color := $0064FFFF;
  CB_op_desc_factura.Visible := TRUE;

  CB_op_desc_factura.Left := E_desc_factura.Left + E_desc_factura.Width + 5;
  CB_op_desc_factura.Top := E_desc_factura.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_PK_movimentoEnter(Sender: TObject);
begin
  E_PK_movimento.Width := 80;
  CB_op_pk_movimento.Items.Clear;
  CB_op_pk_movimento.Text := 'Operador';
  CB_op_pk_movimento.Items.Add('  >  ');
  CB_op_pk_movimento.Items.Add('  <  ');
  CB_op_pk_movimento.Items.Add('  =  ' );
  CB_op_pk_movimento.Items.Add('  <=  ' );
  CB_op_pk_movimento.Items.Add('  >=  ' );
  CB_op_pk_movimento.Items.Add('  between  ');
  CB_op_pk_movimento.Items.Add('  like  ');
//  CB_op_pk_movimento.Items.Add('  ?  ');  // igual ao seguinte
  CB_op_pk_movimento.Color := $0064FFFF;
  CB_op_pk_movimento.Visible := TRUE;

  CB_op_pk_movimento.Left := E_PK_movimento.Left + E_PK_movimento.Width + 5;
  CB_op_pk_movimento.Top := E_PK_movimento.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_moeda_debitoChange(Sender: TObject);
begin
  case CB_op_moeda_debito.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_moeda_debito := '>';
    1: op_moeda_debito := '<';
    2: op_moeda_debito := '=';
    3: op_moeda_debito := '<=';
    4: op_moeda_debito := '>=';
    5: op_moeda_debito := 'between';
    6: op_moeda_debito := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_montante_moeda_origEnter(Sender: TObject);
begin
  E_montante_moeda_orig.Width := 100;
  CB_op_montante_moeda_orig.Items.Clear;
  CB_op_montante_moeda_orig.Text:= 'Operador';
  CB_op_montante_moeda_orig.Items.Add('  >  ');
  CB_op_montante_moeda_orig.Items.Add('  <  ');
  CB_op_montante_moeda_orig.Items.Add('  =  ' );
  CB_op_montante_moeda_orig.Items.Add('  <=  ' );
  CB_op_montante_moeda_orig.Items.Add('  >=  ' );
  CB_op_montante_moeda_orig.Items.Add('  between  ');
  CB_op_montante_moeda_orig.Items.Add('  like  ');
  CB_op_montante_moeda_orig.Color := $0064FFFF;
  CB_op_montante_moeda_orig.Visible := TRUE;

  CB_op_montante_moeda_orig.Left := E_montante_moeda_orig.Left + E_montante_moeda_orig.Width + 5;
  CB_op_montante_moeda_orig.Top := E_montante_moeda_orig.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_moeda_debitoEnter(Sender: TObject);
begin
  E_moeda_debito.Width := 100;
  CB_op_moeda_debito.Items.Clear;
  CB_op_moeda_debito.Text:= 'Operador';
  CB_op_moeda_debito.Items.Add('  >  ');
  CB_op_moeda_debito.Items.Add('  <  ');
  CB_op_moeda_debito.Items.Add('  =  ' );
  CB_op_moeda_debito.Items.Add('  <=  ' );
  CB_op_moeda_debito.Items.Add('  >=  ' );
  CB_op_moeda_debito.Items.Add('  between  ');
  CB_op_moeda_debito.Items.Add('  like  ');
  CB_op_moeda_debito.Color := $0064FFFF;
  CB_op_moeda_debito.Visible := TRUE;

  CB_op_moeda_debito.Left := E_moeda_debito.Left + E_moeda_debito.Width + 5;
  CB_op_moeda_debito.Top := E_moeda_debito.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_pk_movimentoChange(Sender: TObject);
begin
  case CB_op_pk_movimento.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_PK_movimento := '>';
    1: op_PK_movimento := '<';
    2: op_PK_movimento := '=';
    3: op_PK_movimento := '<=';
    4: op_PK_movimento := '>=';
    5: op_PK_movimento := 'between';
    6: op_PK_movimento := 'like';
    7: op_PK_movimento := 'SQL_livre';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_estadoChange(Sender: TObject);
begin
  case CB_op_estado.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_estado := '>';
    1: op_estado := '<';
    2: op_estado := '=';
    3: op_estado := '<=';
    4: op_estado := '>=';
    5: op_estado := 'between';
    6: op_estado := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_montante_moeda_origChange(
  Sender: TObject);
begin
    case CB_op_montante_moeda_orig.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_montante_moeda_orig := '>';
    1: op_montante_moeda_orig := '<';
    2: op_montante_moeda_orig := '=';
    3: op_montante_moeda_orig := '<=';
    4: op_montante_moeda_orig := '>=';
    5: op_montante_moeda_orig := 'between';
    6: op_montante_moeda_orig := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_montanteChange(Sender: TObject);
begin
  case CB_op_montante.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_credito := '>';
    1: op_credito := '<';
    2: op_credito := '=';
    3: op_credito := '<=';
    4: op_credito := '>=';
    5: op_credito := 'between';
    6: op_credito := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_nome_comercioChange(Sender: TObject);
begin
  case CB_op_nome_comercio.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_data_val := '>';
    1: op_data_val := '<';
    2: op_data_val := '=';
    3: op_data_val := '<=';
    4: op_data_val := '>=';
    5: op_data_val := 'between';
    6: op_data_val := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_taxas_comissoesChange(Sender: TObject);
begin
  case CB_op_taxas_comissoes.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_debito := '>';
    1: op_debito := '<';
    2: op_debito := '=';
    3: op_debito := '<=';
    4: op_debito := '>=';
    5: op_debito := 'between';
    6: op_debito := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.CB_op_desc_facturaChange(Sender: TObject);
begin
  case CB_op_desc_factura.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_desc_factura := '>';
    1: op_desc_factura := '<';
    2: op_desc_factura := '=';
    3: op_desc_factura := '<=';
    4: op_desc_factura := '>=';
    5: op_desc_factura := 'between';
    6: op_desc_factura := 'like';
  end;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_estadoEnter(Sender: TObject);
begin
  E_estado.Width := 105;
  CB_op_estado.Items.Clear;
  CB_op_estado.Text:= 'Operador';
  CB_op_estado.Items.Add('  >  ');
  CB_op_estado.Items.Add('  <  ');
  CB_op_estado.Items.Add('  =  ' );
  CB_op_estado.Items.Add('  <=  ' );
  CB_op_estado.Items.Add('  >=  ' );
  CB_op_estado.Items.Add('  between  ');
  CB_op_estado.Items.Add('  like  ');
  CB_op_estado.Color := $0064FFFF;
  CB_op_estado.Visible := TRUE;

  CB_op_estado.Left := E_estado.Left + E_estado.Width + 5;
  CB_op_estado.Top := E_estado.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_nome_comercioEnter(Sender: TObject);
begin
  E_nome_comercio.Width := 105;
  CB_op_nome_comercio.Items.Clear;
  CB_op_nome_comercio.Text:= 'Operador';
  CB_op_nome_comercio.Items.Add('  >  ');
  CB_op_nome_comercio.Items.Add('  <  ');
  CB_op_nome_comercio.Items.Add('  =  ' );
  CB_op_nome_comercio.Items.Add('  <=  ' );
  CB_op_nome_comercio.Items.Add('  >=  ' );
  CB_op_nome_comercio.Items.Add('  between  ');
  CB_op_nome_comercio.Items.Add('  like  ');
  CB_op_nome_comercio.Color := $0064FFFF;
  CB_op_nome_comercio.Visible := TRUE;

  CB_op_nome_comercio.Left := E_nome_comercio.Left + E_nome_comercio.Width + 5;
  CB_op_nome_comercio.Top := E_nome_comercio.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_notasEnter(Sender: TObject);
begin
  E_notas.Width := 50;
  CB_op_notas.Items.Clear;
  CB_op_notas.Text:= 'Operador';
  CB_op_notas.Items.Add('  >  ');
  CB_op_notas.Items.Add('  <  ');
  CB_op_notas.Items.Add('  =  ' );
  CB_op_notas.Items.Add('  <=  ' );
  CB_op_notas.Items.Add('  >=  ' );
  CB_op_notas.Items.Add('  between  ');
  CB_op_notas.Items.Add('  like  ');
  CB_op_notas.Color := $0064FFFF;
  CB_op_notas.Visible := TRUE;

  CB_op_notas.Left := E_notas.Left + E_notas.Width + 5;
  CB_op_notas.Top := E_notas.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.E_taxas_comissoesEnter(Sender: TObject);
begin
  E_taxas_comissoes.Width := 100;
  CB_op_taxas_comissoes.Items.Clear;
  CB_op_taxas_comissoes.Text:= 'Operador';
  CB_op_taxas_comissoes.Items.Add('  >  ');
  CB_op_taxas_comissoes.Items.Add('  <  ');
  CB_op_taxas_comissoes.Items.Add('  =  ' );
  CB_op_taxas_comissoes.Items.Add('  <=  ' );
  CB_op_taxas_comissoes.Items.Add('  >=  ' );
  CB_op_taxas_comissoes.Items.Add('  between  ');
  CB_op_taxas_comissoes.Items.Add('  like  ');
  CB_op_taxas_comissoes.Color := $0064FFFF;
  CB_op_taxas_comissoes.Visible := TRUE;

  CB_op_taxas_comissoes.Left := E_taxas_comissoes.Left + E_taxas_comissoes.Width + 5;
  CB_op_taxas_comissoes.Top := E_taxas_comissoes.Top;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.FormCreate(Sender: TObject);
begin
  Width := 570;
//  DragMode
  E_Cartao_Activo.DragMode := dmAutomatic;
  L_Cartao_Activo.DragMode := dmAutomatic;
  E_PK_movimento.DragMode := dmAutomatic;
  L_PK_movimento.DragMode := dmAutomatic;
  E_PK_movimento.DragMode := dmAutomatic;
  L_PK_movimento.DragMode := dmAutomatic;
  E_estado.DragMode := dmAutomatic;
  L_estado.DragMode := dmAutomatic;
  E_nome_comercio.DragMode := dmAutomatic;
  L_nome_comercio.DragMode := dmAutomatic;
  E_desc_factura.DragMode := dmAutomatic;
  L_desc_factura.DragMode := dmAutomatic;
  E_taxas_comissoes.DragMode := dmAutomatic;
  L_taxas_comissoes.DragMode := dmAutomatic;
  E_montante.DragMode := dmAutomatic;
  L_montante.DragMode := dmAutomatic;
  E_montante_moeda_orig.DragMode := dmAutomatic;
  L_montante_moeda_orig.DragMode := dmAutomatic;
  E_moeda_debito.DragMode := dmAutomatic;
  L_moeda_debito.DragMode := dmAutomatic;
  E_cod_tipo_movimento.DragMode := dmAutomatic;
  L_cod_tipo_movimento.DragMode := dmAutomatic;
  E_analisado.DragMode := dmAutomatic;
  L_analisado.DragMode := dmAutomatic;

  Top := frm_edita_cc_nb_movimentos.Top + 120;
  Left := frm_edita_cc_nb_movimentos.Left + 700;
end;

procedure Tfrm_prep_query_cc_nb_movimentos.FormHide(Sender: TObject);
var
  i:integer;
begin
  for i := 0 to frm_edita_cc_nb_movimentos.DBG_movimentos_cc_nb.Columns.Count -1 do      // limpa os UP e DOWN dos títulos de todas as colunas antes de cada ordenação por qualquer coluna
  begin
    frm_edita_cc_nb_movimentos.DBG_movimentos_cc_nb.Columns.Items[i].Title.ImageIndex := 2;
  end;
end;

end.
