unit u_dm_movimentos;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Buttons, PQConnection, SQLDB, DB, IniFiles, Dialogs;

type

  { Tfrm_DM_movimentos }

  Tfrm_DM_movimentos = class(TDataModule)
    DS_cartoes_nb: TDataSource;
    DS_total_cartoes_nb: TDataSource;
    DS_Movimentos_NB: TDataSource;
    DS_analisado: TDataSource;
    DS_tipo_despesa: TDataSource;
    DS_tipo_fisco: TDataSource;
    DS_grupo_IRS: TDataSource;
    DS_facturas: TDataSource;
    DS_totais_debito_credito_nb: TDataSource;
    DS_total_movimentos_CGD: TDataSource;
    DS_totais_debito_credito_cgd: TDataSource;
    DS_movimentos_CGD: TDataSource;
    DS_tipos_movimento: TDataSource;
    DS_total_movimentos_NB: TDataSource;
    PQC_movimentos: TPQConnection;
    SQLQ_cartoes_nb: TSQLQuery;
    SQLQ_total_cartoes_nb: TSQLQuery;
    SQLQ_Movimentos_NB: TSQLQuery;
    SQLQ_facturas: TSQLQuery;
    SQLQ_analisado: TSQLQuery;
    SQLQ_analisadoanalisado: TStringField;
    SQLQ_analisadodescricao: TStringField;
    SQLQ_grupo_IRS: TSQLQuery;
    SQLQ_grupo_IRSano_ref: TBCDField;
    SQLQ_grupo_IRScod_grupo_irs: TBCDField;
    SQLQ_grupo_IRSdesc_grupo_irs: TStringField;
    SQLQ_tipo_despesa: TSQLQuery;
    SQLQ_tipo_despesaano_ref: TBCDField;
    SQLQ_tipo_despesacod_tipo_despesa: TBCDField;
    SQLQ_tipo_despesadesc_tipo_despesa: TStringField;
    SQLQ_tipo_fisco: TSQLQuery;
    SQLQ_facturas2ano_ref: TBCDField;
    SQLQ_facturas2cod_grupo_irs: TBCDField;
    SQLQ_facturas2cod_tipo_despesa: TBCDField;
    SQLQ_facturas2cod_tipo_fisco: TBCDField;
    SQLQ_facturas2data_factura: TDateField;
    SQLQ_facturas2descricao_despesa: TStringField;
    SQLQ_facturas2iliquido: TBCDField;
    SQLQ_facturas2iva: TBCDField;
    SQLQ_facturas2liquido: TBCDField;
    SQLQ_facturas2nome_fornecedor: TStringField;
    SQLQ_facturas2num_factura: TStringField;
    SQLQ_facturas2pk_facturas: TBCDField;
    SQLQ_facturas2tx_iva: TBCDField;
    SQLQ_tipo_fiscoano_ref: TBCDField;
    SQLQ_tipo_fiscocod_tipo_fisco: TBCDField;
    SQLQ_tipo_fiscodesc_tipo_fisco: TStringField;
    SQLQ_totais_debito_credito_nb: TSQLQuery;
    SQLQ_totais_debito_credito_cgdcredito1: TBCDField;
    SQLQ_totais_debito_credito_cgddebito1: TBCDField;
    SQLQ_totais_debito_credito_nbconta: TMemoField;
    SQLQ_total_movimentos_CGD: TSQLQuery;
    SQLQ_totais_debito_credito_cgd: TSQLQuery;

    SQLQ_totais_debito_credito_cgdcredito: TBCDField;
    SQLQ_totais_debito_credito_cgddebito: TBCDField;

    SQLQ_movimentos_CGD: TSQLQuery;
    SQLQ_movimentos_CGDanalisado: TStringField;
    SQLQ_movimentos_CGDcategoria: TStringField;
    SQLQ_movimentos_CGDcod_tipo_movimento: TLongintField;
    SQLQ_movimentos_CGDcredito: TBCDField;
    SQLQ_movimentos_CGDdata_mov: TDateField;
    SQLQ_movimentos_CGDdata_valor: TDateField;
    SQLQ_movimentos_CGDdebito: TBCDField;
    SQLQ_movimentos_CGDdescricao: TStringField;
    SQLQ_movimentos_CGDnotas: TStringField;
    SQLQ_movimentos_CGDpk_movimentos_cgd: TLongintField;
    SQLQ_movimentos_CGDsaldo_contabilistico: TBCDField;
    SQLQ_movimentos_CGDsaldo_disponivel: TBCDField;
    SQLQ_tipos_movimento: TSQLQuery;
    SQLQ_tipos_movimentocod_tipo_movimento: TLongintField;
    SQLQ_tipos_movimentodescricao: TStringField;
    SQLQ_total_movimentos_NB: TSQLQuery;
    SQLQ_total_movimentos_CGDtotal_registos: TLargeintField;
    SQLQ_total_movimentos_CGDtotal_registos1: TLargeintField;
    SQLT_movimentos: TSQLTransaction;
    procedure DataModuleCreate(Sender: TObject);

  private

  public

  end;

var
  frm_DM_movimentos: Tfrm_DM_movimentos;

implementation

{$R *.frm}

{ Tfrm_DM_movimentos }

procedure Tfrm_DM_movimentos.DataModuleCreate(Sender: TObject);
  const
    USER_NAME_SECTION = 'USER-NAME';
    PASSWORD_SECTION = 'USER-PASSWORD';
    HOST_ADDRESS_SECTION = 'HOST-ADDRESS';
    HOST_PORT_SECTION = 'HOST-PORT';

var
  INI: TINIFile;
  User_Name,
  Password,
  HostName,
  Port:    string;
begin
  INI := TINIFile.Create('base_conta.ini');
  User_Name := INI.ReadString(USER_NAME_SECTION,'UserName','');
  Password := INI.ReadString(PASSWORD_SECTION,'Password','');
  HostName := INI.ReadString(HOST_ADDRESS_SECTION,'HostName','');
  Port := INI.ReadString(HOST_PORT_SECTION,'Port','');
  Port := 'port=' + Port;
  INI.Free;




// INÍCIO da experiência

// desliga todos os queries
    SQLQ_Movimentos_NB.Active := FALSE;
    SQLQ_facturas.Active := FALSE;
    SQLQ_analisado.Active := FALSE;
    SQLQ_grupo_IRS.Active := FALSE;
    SQLQ_tipo_despesa.Active := FALSE;
    SQLQ_tipo_fisco.Active := FALSE;
    SQLQ_totais_debito_credito_nb.Active := FALSE;
    SQLQ_total_movimentos_CGD.Active := FALSE;
    SQLQ_totais_debito_credito_cgd.Active := FALSE;
    SQLQ_movimentos_CGD.Active := FALSE;
    SQLQ_tipos_movimento.Active := FALSE;
    SQLQ_total_movimentos_NB.Active := FALSE;
//
// desliga a ligação e inicializa com string vazia todos os parâmetros da ligação
    PQC_Movimentos.Connected := FALSE;
    PQC_Movimentos.UserName := '';  // showmessage('After CLEAR - UserName:   ' + PQC_Movimentos.UserName);
    PQC_Movimentos.Password := '';  // showmessage('After CLEAR - Password:   ' + PQC_Movimentos.Password);
    PQC_Movimentos.HostName := '';  // showmessage('After CLEAR - HostName:   ' + PQC_Movimentos.HostName);
    PQC_Movimentos.Params.Clear;    // showmessage('After CLEAR - Params:     ' + PQC_Movimentos.Params.text);
//
// recolhe os parâmetros presentes no INI file destinados a serem utilizados nas ligações que serão feitas a seguir
    PQC_Movimentos.UserName := User_Name;
    PQC_Movimentos.Password := Password;
    PQC_Movimentos.HostName := HostName;
    PQC_Movimentos.Params.AddText(Port);
//
// finalmente re-liga, um a um, todos os queries reafirmando os valores de Database e Transaction
    SQLQ_Movimentos_NB.Database := PQC_Movimentos;
    SQLQ_Movimentos_NB.Transaction := SQLT_Movimentos;
    SQLQ_Movimentos_NB.Active := TRUE;

    SQLQ_facturas.Database := PQC_Movimentos;
    SQLQ_facturas.Transaction := SQLT_Movimentos;
    SQLQ_facturas.Active := TRUE;

    SQLQ_analisado.Database := PQC_Movimentos;
    SQLQ_analisado.Transaction := SQLT_Movimentos;
    SQLQ_analisado.Active := TRUE;

    SQLQ_grupo_IRS.Database := PQC_Movimentos;
    SQLQ_grupo_IRS.Transaction := SQLT_Movimentos;
    SQLQ_grupo_IRS.Active := TRUE;

    SQLQ_tipo_despesa.Database := PQC_Movimentos;
    SQLQ_tipo_despesa.Transaction := SQLT_Movimentos;
    SQLQ_tipo_despesa.Active := TRUE;

    SQLQ_tipo_fisco.Database := PQC_Movimentos;
    SQLQ_tipo_fisco.Transaction := SQLT_Movimentos;
    SQLQ_tipo_fisco.Active := TRUE;

    SQLQ_totais_debito_credito_nb.Database := PQC_Movimentos;
    SQLQ_totais_debito_credito_nb.Transaction := SQLT_Movimentos;
    SQLQ_totais_debito_credito_nb.Active := TRUE;

    SQLQ_total_movimentos_CGD.Database := PQC_Movimentos;
    SQLQ_total_movimentos_CGD.Transaction := SQLT_Movimentos;
    SQLQ_total_movimentos_CGD.Active := TRUE;

    SQLQ_totais_debito_credito_cgd.Database := PQC_Movimentos;
    SQLQ_totais_debito_credito_cgd.Transaction := SQLT_Movimentos;
    SQLQ_totais_debito_credito_cgd.Active := TRUE;

    SQLQ_movimentos_CGD.Database := PQC_Movimentos;
    SQLQ_movimentos_CGD.Transaction := SQLT_Movimentos;
    SQLQ_movimentos_CGD.Active := TRUE;

    SQLQ_tipos_movimento.Database := PQC_Movimentos;
    SQLQ_tipos_movimento.Transaction := SQLT_Movimentos;
    SQLQ_tipos_movimento.Active := TRUE;

    SQLQ_total_movimentos_NB.Database := PQC_Movimentos;
    SQLQ_total_movimentos_NB.Transaction := SQLT_Movimentos;
    SQLQ_total_movimentos_NB.Active := TRUE;

    SQLQ_cartoes_nb.Database := PQC_Movimentos;
    SQLQ_cartoes_nb.Transaction := SQLT_Movimentos;
    SQLQ_cartoes_nb.Active := TRUE;



// FIM da experiência

 {                       funcionava antes da experiencia
  SQLQ_Movimentos_NB.Open;
  SQLQ_totais_debito_credito_nb.Open;
  SQLQ_total_movimentos_NB.Open;

  SQLQ_facturas.Open;
  SQLQ_tipo_despesa.Open;
  SQLQ_tipo_fisco.Open;
  SQLQ_grupo_IRS.Open;

  SQLQ_total_movimentos_CGD.Open;
  SQLQ_totais_debito_credito_cgd.Open;

  SQLQ_analisado.Open;


}



{
  PQC_Movimentos.UserName := '';  showmessage('After CLEAR - UserName:   ' + PQC_Movimentos.UserName);
  PQC_Movimentos.Password := '';  showmessage('After CLEAR - Password:   ' + PQC_Movimentos.Password);
  PQC_Movimentos.HostName := '';  showmessage('After CLEAR - HostName:   ' + PQC_Movimentos.HostName);
  PQC_Movimentos.Params.Clear;    showmessage('After CLEAR - Params:     ' + PQC_Movimentos.Params.text);

//  PQC_Movimentos.Connected := FALSE;

  PQC_Movimentos.UserName := User_Name;
  PQC_Movimentos.Password := Password;
  PQC_Movimentos.HostName := HostName;
  PQC_Movimentos.Params.AddText(Port);


  showmessage('Depois - UserName:   ' + PQC_Movimentos.UserName);
  showmessage('Depois - Password:   ' + PQC_Movimentos.Password);
  showmessage('Depois - HostName:   ' + PQC_Movimentos.HostName);
  showmessage('Depois - Params:     ' + PQC_Movimentos.Params.text);


  Showmessage('Antes - User_Name:  ' + PQC_Movimentos.UserName + '    Password:  ' + PQC_Movimentos.Password + '   User_Name:  ' + PQC_Movimentos.UserName + '   Password:  ' + PQC_Movimentos.Password);
  Showmessage('Novos: - User_Name:  ' + User_Name + '     - Password:  ' + Password + '     - HostName:  ' + HostName + '     - Port:  ' + Port);
}

  PQC_Movimentos.Connected := TRUE;
end;

end.
